(	
global MFL_Rollout
	try (destroydialog MFL_Rollout)catch()
	
	local getLayer = undefined
	local objList  = undefined
	local re = undefined
	local newMask = undefined
	
	rollout MFL_Rollout "Masks from Render Layers"
(
	button 'btn1' "Create" pos:[10,10] width: 240 height: 40 align:#center tooltip: "This script will create a MultiMatteElement for all objects in each non-empty Render Layer. It will set G-Buffer IDs for the objects in the respective layer. Note: Empty Render Layers will be deleted."
	label 'edt4' " Chaos 3D Support Team" pos:[120,60]
	hyperlink 'link1' "V-Ray Knowledge Base" pos:[140,75] color: (color 39 200 255) hovercolor: (color 39 140 255) address:"https://support.chaos.com/hc/en-us/sections/10633063984273-V-Ray-Knowledge-Base-"
	
	fn isVRayCurrent = matchPattern (renderers.current as string) pattern:"*V_RAY*"
	fn delete_empty_layers = (
	local counter = 0
 
	for id = LayerManager.count - 1 to 1 by -1 do
	(
		local layer = LayerManager.getLayer id
 
		local contains_nodes = LayerManager.doesLayerHierarchyContainNodes layer.name
 
		if not contains_nodes then
		(
			local deleted = LayerManager.deleteLayerByName layer.name
 
			if deleted then counter += 1
		)
	)
 
	return counter
	)
	fn layerToMask = (
	for i=0 to layerManager.count - 1 do
	(
		clearSelection()
		getLayer = layerManager.getLayer i
		getLayer.select true
		
		objList = getCurrentSelection()
		for p=1 to objList.count do 
		(
		select objList[p]
		$.gbufferchannel = i + 1
		)	
		
		re=maxOps.GetCurRenderElementMgr()
		newMask = MultiMatteElement()
		newMask.ElementName = getLayer.name
		newmask.R_gbufID = i + 1
		newmask.G_gbufID = i + 1
		newmask.B_gbufID = i + 1
		re.AddRenderElement(newMask) 
	)	
	)
		
	on btn1 pressed do 
	(
		if isVRayCurrent() == true then print "Okay." else return messageBox "V-Ray is not set to current renderer!" title: "Error!"
		delete_empty_layers()
		layerToMask()
	)
)
	createDialog MFL_Rollout 260 100
)